//  Version 1.02    2022-12-31
#define DWORD   unsigned long
#define  WORD   unsigned short
#define  BYTE   unsigned char
//#include    <std.h>
#include    <stdio.h>
#include    <stdlib.h>
#include    <io.h>
#include    <string.h>
#include    <memory.h>
#include    "keydef.h"
#include    <nocrt0.h>
#include    <iomem.h>
#include    <pc98con.h>
#include    <dosio.h>
#include    <dos.h>

static  WORD   EEPROM[32];
static  WORD    NOULTRA   =1;     // ==1 ultra    ==0 fast

typedef  struct {
    DWORD  SizeL;
    WORD   Size;
    int    Handle;
    int    Status;
    char   *Name;
}   FILESPEC_T;
static FILESPEC_T  File1={ 64L, 64, -1, 0, NULL};

static WORD col[8]={16,24,32,40,48,56,64,72};
static  int x0=1;

typedef  struct {
    int Title;
    int Start;
    int Config;
    int Success;
    int Bottom;
}   ROW_T;
static ROW_T   Row = { 0, 7, 14, 21 ,24};

typedef struct  {
   BYTE sync;   BYTE xfer;  BYTE discon;
   BYTE sucmd;  BYTE scan;  BYTE ultra;
}  SCSI_CONFIG_T;       // SCSI configureationX̃p[^i[\
static SCSI_CONFIG_T  aha[16];  // SCSI IDԂ̂W̔zŊm

static  WORD io_base,busnumber,devid,subven;

#include    "fileio.c"


int HighLight(int curpos_x,  int curpos_y, int sw)
{   int row;    // Ō̃p[^1̂ƂnCCgA0̂Ƃm[}\ 
    row=curpos_y;
    if (sw)     putatr(x0+col[curpos_x]-1, Row.Config+row, 0xC5, 6);
        else    putatr(x0+col[curpos_x]-1, Row.Config+row, 0xE1, 6);
    return(0);
}

void put_sync(int id)   // ^񓯊̐ݒ\ ID ŃRʒuς
{   char *sp;   int row=1;
    if (aha[id].sync) sp="  ";  else  sp="񓯊";
    putstr(col[id], Row.Config+row, 0xE1, (void far*)sp);
}

void    set_rate(int id)    // ]x̐ݒ\ ID ŃRʒuς
{   int row=2;
    char *sp;   int rate;
        rate =(WORD)aha[id].xfer;
        if (aha[id].ultra==0) {
            switch (rate)   {
                case 0: sp="  **  "; break;
                case 1: sp="  T  "; break; 
                case 2: sp="  6.6 "; break; 
                case 3: sp="  8.0 "; break; 
                case 4: sp=" PO "; break; 
               default: sp=" ?H? "; break; 
            }
        } else {
            switch (rate)   {
                case 0: sp="  --  "; break;
                case 1: sp="  T  "; break; 
                case 2: sp="  6.6 "; break; 
                case 3: sp="  8.0 "; break; 
                case 4: sp=" PO "; break; 
                case 5: sp=" 13.3 "; break; 
                case 6: sp=" 16.0 "; break; 
                case 7: sp=" QO "; break; 
               default: sp=" HH "; break; 
            }
        }
    if (aha[id].sync ==0) {
        aha[id].xfer=0;    
         sp=" **** ";
    }
    putstr(col[id], Row.Config+row, 0xE1, (void far*)sp);
}

void    put_ultra(int id)   
{   char *sp;   int row=0;  // Ultra]ۂ̐ݒ\, ID ŃRʒuς
    if (aha[id].ultra) {
        sp=" ULTRA";  
    } else  {
        sp=" fast ";
      if (aha[id].xfer >= 4) aha[id].xfer=4;
//        if (aha[id].xfer >= 3) aha[id].xfer=2;
    }
    putstr(col[id], Row.Config+row, 0xE1, (void far*)sp);
    set_rate(id);
}

void    put_discon(int id)  
{   char *sp;   int row=3;  // Disconnectېݒ\ ID ŃRʒuς
    if (aha[id].discon) sp="  "; else sp="Ȃ";
    putstr(col[id], Row.Config+row,0xE1, (void far*)sp);
}

void    put_sucmd(int id)
{   char *sp;   int row=4;  // Start Unit command̉ېݒ\ 
    if (aha[id].sucmd) sp=" o "; else sp=" ---- ";
    putstr(col[id], Row.Config+row, 0xE1, (void far*)sp);
}   // ID ŕ\̃Rʒuς

void    put_scan(int id)
{   char *sp;   int row=5;  // BIOS scanۂ̐ݒ\
    if (aha[id].scan) sp="  "; else sp="  ";
    putstr(col[id], Row.Config+row,0xE1, (void far*)sp);
}   // ID ŕ\̃Rʒuς

int DecrimentParam2( int x, int y)
{   int id=x, row=y;    // BSL[ꂽƂ,]x͑Oɕω
    if (y==2)   {
        if (aha[id].ultra)  {
            if (aha[id].xfer > 1) aha[id].xfer--;   else  aha[id].xfer=7;
        } else {
            if (aha[id].xfer > 1) aha[id].xfer--;   else  aha[id].xfer=4;
        }
        set_rate(id);
        return(2);
    } else {
        return(0);
    }
}

int ChangeParam( int x, int y ) 
{   int id=x;    // CRLFꂽƂ̏
    if (y==0)   {
        if (aha[id].ultra) aha[id].ultra=0;  else aha[id].ultra=1;
        put_ultra(id);  // EgȂ炻𔽓]
        return(1);
    }
    if (y==1)   {
        if (aha[id].sync) aha[id].sync=0;  else aha[id].sync=1;
        put_sync(id);   // E񓯊𔽓]
        return(1);
    }
    if (y==3)   {
        if (aha[id].discon) aha[id].discon=0;   else aha[id].discon=1;
        put_discon(id); // fBXRlNgۂ𔽓]
        return(3);
    }
    if (y==4)   {
        if (aha[id].sucmd) aha[id].sucmd=0;   else aha[id].sucmd=1;
        put_sucmd(id);  // X^[gEjbgER}h𔭍s邩ǂ]
        return(4);
    }
    if (y==5)   {
        if (aha[id].scan) aha[id].scan=0;   else aha[id].scan=1;
        put_scan(id);   // BIOS̃XLΏۂ̉ۂ𔽓]
        return(5);
    }
    if (y==2)   {   // ]x 0..7܂ł
        if (aha[id].ultra)  {
            if (aha[id].xfer < 7) aha[id].xfer++;   else  aha[id].xfer=1;
            if (aha[id].xfer ==2 || aha[id].xfer ==3 )  aha[id].xfer ==4;
            if (aha[id].xfer ==5 || aha[id].xfer ==6 )  aha[id].xfer ==7;
        } else {
            if (aha[id].xfer < 4) aha[id].xfer++;   else  aha[id].xfer=1;
        }
        set_rate(id);
    }
}


int SelectParam2D()
{   int    curpos_x=0, curpos_y=NOULTRA;
    unsigned char c;
    HighLight(curpos_x, curpos_y, 1);
    c = getkey();
    while( c != 27 ) {
        HighLight(curpos_x, curpos_y, 0);   // ܂]nCCg
        switch(c){
            case    LEFT:       if (curpos_x > 0) curpos_x--;   break;
            case    RIGHT:      if (curpos_x < 7) curpos_x++;   break;
            case    UP:         if (curpos_y > (int)NOULTRA) curpos_y--;   break;
            case    DOWN:       if (curpos_y < 5) curpos_y++;   break;
            case    ENTER:      ChangeParam(curpos_x ,curpos_y);    break;
            case    BS:         DecrimentParam2(curpos_x ,curpos_y); break;
            default: break;
        }
        HighLight(curpos_x, curpos_y,1);    // 
        c = getkey();
    }
    HighLight(curpos_x, curpos_y,0); 
    return(c);
}


int ShowParam2D()
{   static char ZenZero[7]="yOz";
    char knjnum[7];
    int id,row;    // ID 07 ܂ł SĂ̗vfɕ\Ă[`
    char *sp;   

    strcpy(knjnum,ZenZero);     // initialized by yOz

    putstr(x0, Row.Config-1, 0xE1, "SCSI ID #");
    for ( id=0;    id<8;  id++){    
        putstr(col[id], Row.Config-1, 0xE1, (void far*)knjnum);
        knjnum[3]++;
    }

    row=0;  putstr(x0, Row.Config+row, 0xE1, "ULTRA̐ݒ");
    for ( id=0;    id<8;  id++){  
        sp=" fast ";
        if (NOULTRA==0) {   // EgΏۋ@Ȃ
            if (aha[id].ultra) sp=" ULTRA"; // \
        } else {        // EgłȂ
            aha[id].ultra=0;    // \Ȃ
        }
        put_ultra(id);
    }

    row=1;  putstr(x0, Row.Config+row, 0xE1, "]");
    for ( id=0;    id<8;  id++){    put_sync(id);    }
    
    row=2;  putstr(x0, Row.Config+row, 0xA1, "ő]MB/s");
    for ( id=0;    id<8;  id++){    set_rate(id);   }
    
    row=3;  putstr(x0, Row.Config+row, 0xE1, "Disconnect");
    for ( id=0;    id<8;  id++){    put_discon(id);  }

    row=4;  putstr(x0, Row.Config+row, 0xE1, "StartUnit");
    for ( id=0;    id<8;  id++){    put_sucmd(id);  }

    row=5;  putstr(x0, Row.Config+row, 0xE1, "BIOSł̔F");
    for ( id=0;    id<8;  id++){    put_scan(id);   }
    return(0);
}

void ProgramTitle()
{   static char title1[]=
    "Adaptec AHA-2940/J95, 2940AU/J97 PCI SCSI adapter UNOFFICIAL SCSI utility";
    static char title2[]=
    "SCU   EEPROM.64 쐬xc[   Version 1.02 (2022/12/31)";

    putchr( 0, Row.Title+0, 0x21, 79, 0x95);
    putstr( 2, Row.Title+1, 0xE1, title1);
    putstr( 2, Row.Title+2, 0xE1, title2);
    putchr( 0, Row.Title+3, 0x21, 79, 0x95);
}

void    SendData()
{   int id,rate2,xfer;
    WORD    wsum;
    
    for (id=0; id<8; id++) {
        xfer=(int)aha[id].xfer;
        if (aha[id].ultra) {    // Eg̏ꍇ̉
            switch ( xfer ) {
                case 0:  rate2=0x40;    break;
                case 1:  rate2=0x04;    break;  // 5M
                case 2:  rate2=0x02;    break;  // 6.6
                case 3:  rate2=0x01;    break;  // 8
                case 4:  rate2=0x44;    break;  // 10
                case 5:  rate2=0x42;    break;  // 13.3
                case 6:  rate2=0x41;    break;  // 16
                case 7:  rate2=0x40;    break;  // 20MB/s
                default: rate2=0x40;    break;
            };
        } else {        // e`rs̏ꍇ̉
            switch ( xfer ) {
                case 0:  rate2=0x04;  break;    // 10.0M async
                case 1:  rate2=0x04;  break;    // 5M
                case 2:  rate2=0x02;  break;    // 6.6M
                case 3:  rate2=0x01;  break;    // 8.0M
                case 4:  rate2=0x00;  break;    // 10.0M
                default: rate2=0x00;  break;
            };
        }   
//  vff[^ EEPROMIDf[^\z
        EEPROM[id]= (aha[id].scan <<9) + (aha[id].sucmd <<8) + 
         (aha[id].discon <<4) + (aha[id].sync <<3) + (aha[id].ultra <<7) + rate2;
    }
// `FbNT߂    
    wsum=0;     EEPROM[31]=0;   // TۊǏꏊ̓[ŏ
#if 0
    for (id=8;  id<16;  id++) { // Chrbrhp̂ƂFFFFŒׂ
        EEPROM[id]=0xFFFF;
    }
#endif
    for (id=0;  id<32;  id++) { 
        wsum+=EEPROM[id];   // T߂
    }
    EEPROM[ 0x1F ]=wsum;  // ʒuɃTi[T[͂Ȃj
//    printf("WSUM = %4.4X ",wsum);

}

void    RecieveData()
{   int id,rate2;   // EEPROMIDf[^vfɕ
    for (id=0; id<8; id++) {
        if (EEPROM[id] & 0x0080)  aha[id].ultra=1; else  aha[id].ultra=0; 
        if (EEPROM[id] & 0x0200)  aha[id].scan=1; else  aha[id].scan=0; 
        if (EEPROM[id] & 0x0100)  aha[id].sucmd=1; else aha[id].sucmd=0;
        if (EEPROM[id] & 0x0010)  aha[id].discon=1; else aha[id].discon=0;
        if (EEPROM[id] & 0x0008)  aha[id].sync=1; else aha[id].sync=0;
        rate2=EEPROM[id] & 0x0047;

        if (aha[id].ultra) {
            switch ( rate2 ) {
                case 0x00:   aha[id].xfer=0;  break;    //
                case 0x04:   aha[id].xfer=1;  break;    // 5M
                case 0x02:   aha[id].xfer=2;  break;    // 6.6
                case 0x01:   aha[id].xfer=3;  break;    // 8
                case 0x44:   aha[id].xfer=4;  break;    // 10M
                case 0x42:   aha[id].xfer=5;  break;    // 13.3
                case 0x41:   aha[id].xfer=6;  break;    // 16
                case 0x40:   aha[id].xfer=7;  break;    // 20MB/s
                default:     aha[id].xfer=0;  break;    // 
            };

        } else {
            switch ( rate2 ) {
                case 0x00:   aha[id].xfer=4;  break;    // 10.0M
                case 0x04:   aha[id].xfer=1;  break;    // 5M
                case 0x02:   aha[id].xfer=2;  break;    // 6.6M
                case 0x01:   aha[id].xfer=3;  break;    // 8.0M
                default:     aha[id].xfer=4;  break;    // 
            };
        }
    }
}

#include "SELHORMN.C"

#define NMN_HOSTID  8
#define NMN_PARITY  2
#define NMN_TERMIN  3
#define NMN_ULTRAS  2
int     main1()
{   int rc,selP,selH,selT,selU,eeprom11;
    static  char title2[]=
    "SCSIoX^C^[tFCX̒`s܂.";
    static  char title3[]=
    "SCSIfoCX(ID)Ƃ̐ݒs܂.";
    static char bottom1[]=
    "@Fڈړ     ESCFI      ENTERFύXilj    BSFl ";
    static char bottom0[]="";
    static  char *MN_HostID[ NMN_HOSTID+1 ]=
    {" O "," P "," Q "," R "," S "," T "," U "," V ","zXgA_v^SCSI ID #"};
    static  char *MN_Parity[ NMN_PARITY+1 ]=
    {"  "," L ","SCSIoX̃peB`FbN"};
    static  char *MN_Termin[ NMN_TERMIN+1 ]=
    {"  "," L ","  ","A_v^̃^[~l[V"};
    static  char *MN_UltraS[ NMN_ULTRAS+1 ]=
    {" ͂ ","","Ultra SCSIA_v^p̐ݒ肩H"};
    static char explainT[]=
    " AOtڑ̂Ƃ́uLvAǂڑ̂Ƃ́uv";
    static char explainP[]=
    " ʏ́uLvɐݒ肷邱";
    static char explainID[]=
    " ʏ́uVvɐݒ肷邱";

    RecieveData();
    putstr(0,Row.Start-1, 0x81, title2);

        SelectHorizonMenu(NMN_ULTRAS, selU, Row.Start+0,  MN_UltraS, 1 );
        SelectHorizonMenu(NMN_HOSTID, selH, Row.Start+1,  MN_HostID, 1 );
        SelectHorizonMenu(NMN_PARITY, selP, Row.Start+2,  MN_Parity, 1 );
        SelectHorizonMenu(NMN_TERMIN, selT, Row.Start+3,  MN_Termin, 1 );

    selU=1;
    rc =SelectHorizonMenu(NMN_ULTRAS, selU, Row.Start+0,  MN_UltraS, 0 );
    if (rc==-1) return(255);
    NOULTRA=rc;

    
    selH = EEPROM[0x12] & 0x001F;
    selP = (EEPROM[0x11] & 0x0040) >>6;
    eeprom11=EEPROM[0x11] & 0x0007;

    if (NOULTRA)    {
             if (eeprom11==0x9) selT = 2; 
        else if (eeprom11==0xC) selT = 1; 
        else if (eeprom11==0x8) selT = 0; 
        else  selT=1;
    } else {
             if (eeprom11==0x7) selT = 2; 
        else if (eeprom11==0x6) selT = 1; 
        else if (eeprom11==0x2) selT = 0; 
        else  selT=1;
    }

    putstr(2,Row.Start+5, 0xC1, explainID);
    rc =SelectHorizonMenu(NMN_HOSTID, selH, Row.Start+1,  MN_HostID, 0 );
    if (rc==-1) return(255);
    EEPROM[0x12] &=0xFFE0;
    if (rc) EEPROM[0x12]|=rc;


    putstr(2,Row.Start+5, 0xC1, explainP);
    rc =SelectHorizonMenu(NMN_PARITY, selP, Row.Start+2,  MN_Parity, 0 );
    if (rc==-1) return(255);
    EEPROM[0x11] &=0xFFEF;  
    if (rc) EEPROM[0x11] |= 0x0010;

    putstr(2,Row.Start+5, 0xC1, explainT);
    rc =SelectHorizonMenu(NMN_TERMIN, selT, Row.Start+3,  MN_Termin, 0 );
    if (rc==-1) return(255);
    EEPROM[0x11] &=0xFFF0;  
    if (NOULTRA)    {
            if (rc==0)  EEPROM[0x11] |= 0x0008;
       else if (rc==1)  EEPROM[0x11] |= 0x000C;
       else if (rc==2)  EEPROM[0x11] |= 0x0009;
       else EEPROM[0x11] |= 0x0009;
    } else {
            if (rc==0)  EEPROM[0x11] |= 0x0002;
       else if (rc==1)  EEPROM[0x11] |= 0x0006;
       else if (rc==2)  EEPROM[0x11] |= 0x0007;
       else EEPROM[0x11] |= 0x0007;
    }
    putchr(0,Row.Start+5, 0xE1, 80, 0x20);

    putstr(0,Row.Config-2, 0x81, title3);
    putstr(0,Row.Bottom,0xE5,bottom0);
    putstr(4,Row.Bottom,0x85,bottom1);
    ShowParam2D();
    rc = SelectParam2D(); if (rc==0) return(255);
    SendData();

// SCSI A_v^IDԍi[Ă鏊
    if ( ( EEPROM[0x12] & 0xFF00 ) == 0 ) {
        EEPROM[0x12] |= 0x2800;
    }
// SCSI foCX̍őڑ\iʂ͂Wj
    EEPROM[0x13]=0x0008;
    return(0);
}

void EndMsg0()
{   static char bottom0[]="";
    static char bottom1[]=
    "     [ENTER]: ̧قɕۑďI                   [Q]uit:jĒ~      ";
    putstr(0,Row.Bottom,0x45,bottom0);
    putstr(4,Row.Bottom,0xE5,bottom1);
}

void EndMsg1()
{
    putstr(0,Row.Success,  0xE1,"f[^t@C EEPROM.64ɕۑ܂.");
    putstr(0,Row.Success+1,0xE1,"SCUs, EEPROM.64 ̃f[^SCSIA_v^ɏŉ.");
}
void EndMsg1E()
{
    putstr(0,Row.Success,  0xE1,"f[^ EEPROM ɕۑ܂.");
}
void EndMsg2()
{   
    putatr(0,Row.Bottom, 0x25, 80);
    putstr(0,Row.Bottom, 0xC1, "I");
}

int     main( )  
{   int c,rc=0;
    static char far msg_cur[]="JgfBNgɂ ";
    static char far msg_rdy[]="ǂݍ݂܂.";

    File1.Name = "EEPROM.ROM";
    cls();
    locate(0,5);    // DOSˑ

    ProgramTitle();

    putstr(0,  Row.Title+4,0xE1, msg_cur );
    putstr(27, Row.Title+4,0xA1, File1.Name );
    putstr(39, Row.Title+4,0xE1, msg_rdy );
    rc = FindFile(File1.Name);   // DOSˑ
    if (rc) return(1);
    rc = ReadFile( (void far*)EEPROM );
    if (rc) return(2);  // DOSˑ
    rc = FileClose();
    if (rc) return(3);  // DOSˑ

    locate(0,22);   // J[\͏ɐ22sڂɔł

//    Row.Start=6;
    rc = main1( );   if (rc) return(rc);    // Cs
    
    EndMsg0();

    c=0;
    while (c != ENTER)  {
        if (c == 'Q' ) return(4);
        c = getkey();
    }
    

    EndMsg1();
    File1.Name="EEPROM.64";
    rc = FileCreate(File1.Name);  // DOSˑ
    if (rc) return(9);
    rc = WriteFile( EEPROM );  // DOSˑ
    if (rc) return(10);
    rc = FileClose();   // DOSˑ
    if (rc) return(11);
    
    EndMsg2();
    return(0);
}

