/* Ľð */
#define shift_key()     key_sense() & 1
#define caps_key()      key_sense() & 2
#define kana_key()      key_sense() & 4
#define graph_key()     key_sense() & 8
#define ctrl_key()      key_sense() & 16
#define cntl_key()      key_sense() & 16

extern  unsigned char getkey(void);
extern  unsigned char key_sense(void);
extern  void clr_kbuf(void);
extern  void    locate(int,int);
extern  void    cls(void);

/* keycode (getkey) */
#define     UP          0xBA
#define     RIGHT       0xBC
#define     DOWN        0xBD
#define     LEFT        0xBB
#define     ROLLUP      0xB6
#define     ROLLDOWN    0xB7
#define     INSKEY      0xB8
#define     DELKEY      0xB9
#define     HELPKEY     0xBF
#define     ENDKEY      0xBF
#define     HCLRKEY     0xBE
#define     HOMEKEY     0xBE
#define     XFERKEY     0xB5
#define     NFERKEY     0xD1
#define     PF1         0xE1
#define     PF2         0xE2
#define     PF3         0xE3
#define     PF4         0xE4
#define     PF5         0xE5
#define     PF6         0xE6
#define     PF7         0xE7
#define     PF8         0xE8
#define     PF9         0xE9
#define     PF10        0xEB

#define     BS          0x08
#define     SPC         0x20
#define     ESC         0x1B
#define     TAB         0x09
#define     ENTER       0x0D
#define     LFEED       0x0A

